// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package predict_torch

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PredictTorchClient is the client API for PredictTorch service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PredictTorchClient interface {
	PredictV1(ctx context.Context, in *RequestV1, opts ...grpc.CallOption) (*ResponseV1, error)
}

type predictTorchClient struct {
	cc grpc.ClientConnInterface
}

func NewPredictTorchClient(cc grpc.ClientConnInterface) PredictTorchClient {
	return &predictTorchClient{cc}
}

func (c *predictTorchClient) PredictV1(ctx context.Context, in *RequestV1, opts ...grpc.CallOption) (*ResponseV1, error) {
	out := new(ResponseV1)
	err := c.cc.Invoke(ctx, "/predict_torch.PredictTorch/PredictV1", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PredictTorchServer is the server API for PredictTorch service.
// All implementations must embed UnimplementedPredictTorchServer
// for forward compatibility
type PredictTorchServer interface {
	PredictV1(context.Context, *RequestV1) (*ResponseV1, error)
	mustEmbedUnimplementedPredictTorchServer()
}

// UnimplementedPredictTorchServer must be embedded to have forward compatible implementations.
type UnimplementedPredictTorchServer struct {
}

func (UnimplementedPredictTorchServer) PredictV1(context.Context, *RequestV1) (*ResponseV1, error) {
	return nil, status.Errorf(codes.Unimplemented, "method PredictV1 not implemented")
}
func (UnimplementedPredictTorchServer) mustEmbedUnimplementedPredictTorchServer() {}

// UnsafePredictTorchServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PredictTorchServer will
// result in compilation errors.
type UnsafePredictTorchServer interface {
	mustEmbedUnimplementedPredictTorchServer()
}

func RegisterPredictTorchServer(s grpc.ServiceRegistrar, srv PredictTorchServer) {
	s.RegisterService(&PredictTorch_ServiceDesc, srv)
}

func _PredictTorch_PredictV1_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RequestV1)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PredictTorchServer).PredictV1(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/predict_torch.PredictTorch/PredictV1",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PredictTorchServer).PredictV1(ctx, req.(*RequestV1))
	}
	return interceptor(ctx, in, info, handler)
}

// PredictTorch_ServiceDesc is the grpc.ServiceDesc for PredictTorch service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var PredictTorch_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "predict_torch.PredictTorch",
	HandlerType: (*PredictTorchServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "PredictV1",
			Handler:    _PredictTorch_PredictV1_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "api/pr-torch/pr-torch.proto",
}
